/* tbl_opts.c generated by valac 0.56.18, the Vala compiler
 * generated from tbl_opts.vala, do not modify */

/* Table of command-line options.

   Copyright (c) 2009-2020 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <getopt.h>
#include <config.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HELP_ELEMENT (help_element_get_type ())
#define HELP_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HELP_ELEMENT, HelpElement))
#define HELP_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HELP_ELEMENT, HelpElementClass))
#define IS_HELP_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HELP_ELEMENT))
#define IS_HELP_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HELP_ELEMENT))
#define HELP_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HELP_ELEMENT, HelpElementClass))

typedef struct _HelpElement HelpElement;
typedef struct _HelpElementClass HelpElementClass;
typedef struct _HelpElementPrivate HelpElementPrivate;
typedef struct _ParamSpecHelpElement ParamSpecHelpElement;

#define TYPE_DOC (doc_get_type ())
#define DOC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOC, Doc))
#define DOC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOC, DocClass))
#define IS_DOC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOC))
#define IS_DOC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOC))
#define DOC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOC, DocClass))

typedef struct _Doc Doc;
typedef struct _DocClass DocClass;
typedef struct _DocPrivate DocPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	ARG_TYPE_function = 1,
	ARG_TYPE_loadfile,
	ARG_TYPE_file
} ArgType;

#define TYPE_ARG_TYPE (arg_type_get_type ())

#define TYPE_OPT (opt_get_type ())
#define OPT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OPT, Opt))
#define OPT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OPT, OptClass))
#define IS_OPT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OPT))
#define IS_OPT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OPT))
#define OPT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OPT, OptClass))

typedef struct _Opt Opt;
typedef struct _OptClass OptClass;
typedef struct _OptPrivate OptPrivate;

#define TYPE_ARG (arg_get_type ())
#define ARG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARG, Arg))
#define ARG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARG, ArgClass))
#define IS_ARG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARG))
#define IS_ARG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARG))
#define ARG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARG, ArgClass))

typedef struct _Arg Arg;
typedef struct _ArgClass ArgClass;
typedef struct _ArgPrivate ArgPrivate;

struct _HelpElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HelpElementPrivate * priv;
};

struct _HelpElementClass {
	GTypeClass parent_class;
	void (*finalize) (HelpElement *self);
};

struct _ParamSpecHelpElement {
	GParamSpec parent_instance;
};

struct _Doc {
	HelpElement parent_instance;
	DocPrivate * priv;
	gchar* text;
};

struct _DocClass {
	HelpElementClass parent_class;
};

struct _Opt {
	HelpElement parent_instance;
	OptPrivate * priv;
	gchar* longname;
	gchar shortname;
	gint arg;
	gchar* argstring;
	gchar* docstring;
};

struct _OptClass {
	HelpElementClass parent_class;
};

struct _Arg {
	HelpElement parent_instance;
	ArgPrivate * priv;
	gchar* argstring;
	gchar* docstring;
};

struct _ArgClass {
	HelpElementClass parent_class;
};

static gpointer help_element_parent_class = NULL;
static gpointer doc_parent_class = NULL;
static gpointer opt_parent_class = NULL;
static gpointer arg_parent_class = NULL;
VALA_EXTERN HelpElement** opts;
VALA_EXTERN gint opts_length1;
HelpElement** opts = NULL;
gint opts_length1 = 0;
static gint _opts_size_ = 0;

VALA_EXTERN gpointer help_element_ref (gpointer instance);
VALA_EXTERN void help_element_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_help_element (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_help_element (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_help_element (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_help_element (const GValue* value);
VALA_EXTERN GType help_element_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HelpElement, help_element_unref)
VALA_EXTERN HelpElement* help_element_construct (GType object_type);
static void help_element_finalize (HelpElement * obj);
static GType help_element_get_type_once (void);
VALA_EXTERN GType doc_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Doc, help_element_unref)
VALA_EXTERN Doc* doc_new (const gchar* text);
VALA_EXTERN Doc* doc_construct (GType object_type,
                    const gchar* text);
static void doc_finalize (HelpElement * obj);
static GType doc_get_type_once (void);
VALA_EXTERN GType arg_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType opt_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Opt, help_element_unref)
VALA_EXTERN Opt* opt_new (const gchar* longname,
              gchar shortname,
              gint arg,
              const gchar* argstring,
              const gchar* docstring);
VALA_EXTERN Opt* opt_construct (GType object_type,
                    const gchar* longname,
                    gchar shortname,
                    gint arg,
                    const gchar* argstring,
                    const gchar* docstring);
static void opt_finalize (HelpElement * obj);
static GType opt_get_type_once (void);
VALA_EXTERN GType arg_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Arg, help_element_unref)
VALA_EXTERN Arg* arg_new (const gchar* argstring,
              const gchar* docstring);
VALA_EXTERN Arg* arg_construct (GType object_type,
                    const gchar* argstring,
                    const gchar* docstring);
static void arg_finalize (HelpElement * obj);
static GType arg_get_type_once (void);
VALA_EXTERN void init_cmdline (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

HelpElement*
help_element_construct (GType object_type)
{
	HelpElement* self = NULL;
#line 24 "src/tbl_opts.vala"
	self = (HelpElement*) g_type_create_instance (object_type);
#line 24 "src/tbl_opts.vala"
	return self;
#line 228 "tbl_opts.c"
}

static void
value_help_element_init (GValue* value)
{
#line 24 "src/tbl_opts.vala"
	value->data[0].v_pointer = NULL;
#line 236 "tbl_opts.c"
}

static void
value_help_element_free_value (GValue* value)
{
#line 24 "src/tbl_opts.vala"
	if (value->data[0].v_pointer) {
#line 24 "src/tbl_opts.vala"
		help_element_unref (value->data[0].v_pointer);
#line 246 "tbl_opts.c"
	}
}

static void
value_help_element_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 24 "src/tbl_opts.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "src/tbl_opts.vala"
		dest_value->data[0].v_pointer = help_element_ref (src_value->data[0].v_pointer);
#line 258 "tbl_opts.c"
	} else {
#line 24 "src/tbl_opts.vala"
		dest_value->data[0].v_pointer = NULL;
#line 262 "tbl_opts.c"
	}
}

static gpointer
value_help_element_peek_pointer (const GValue* value)
{
#line 24 "src/tbl_opts.vala"
	return value->data[0].v_pointer;
#line 271 "tbl_opts.c"
}

static gchar*
value_help_element_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 24 "src/tbl_opts.vala"
	if (collect_values[0].v_pointer) {
#line 282 "tbl_opts.c"
		HelpElement * object;
		object = collect_values[0].v_pointer;
#line 24 "src/tbl_opts.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "src/tbl_opts.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 289 "tbl_opts.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "src/tbl_opts.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 293 "tbl_opts.c"
		}
#line 24 "src/tbl_opts.vala"
		value->data[0].v_pointer = help_element_ref (object);
#line 297 "tbl_opts.c"
	} else {
#line 24 "src/tbl_opts.vala"
		value->data[0].v_pointer = NULL;
#line 301 "tbl_opts.c"
	}
#line 24 "src/tbl_opts.vala"
	return NULL;
#line 305 "tbl_opts.c"
}

static gchar*
value_help_element_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	HelpElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "src/tbl_opts.vala"
	if (!object_p) {
#line 24 "src/tbl_opts.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 320 "tbl_opts.c"
	}
#line 24 "src/tbl_opts.vala"
	if (!value->data[0].v_pointer) {
#line 24 "src/tbl_opts.vala"
		*object_p = NULL;
#line 326 "tbl_opts.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "src/tbl_opts.vala"
		*object_p = value->data[0].v_pointer;
#line 330 "tbl_opts.c"
	} else {
#line 24 "src/tbl_opts.vala"
		*object_p = help_element_ref (value->data[0].v_pointer);
#line 334 "tbl_opts.c"
	}
#line 24 "src/tbl_opts.vala"
	return NULL;
#line 338 "tbl_opts.c"
}

GParamSpec*
param_spec_help_element (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecHelpElement* spec;
#line 24 "src/tbl_opts.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HELP_ELEMENT), NULL);
#line 24 "src/tbl_opts.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "src/tbl_opts.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "src/tbl_opts.vala"
	return G_PARAM_SPEC (spec);
#line 357 "tbl_opts.c"
}

gpointer
value_get_help_element (const GValue* value)
{
#line 24 "src/tbl_opts.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HELP_ELEMENT), NULL);
#line 24 "src/tbl_opts.vala"
	return value->data[0].v_pointer;
#line 367 "tbl_opts.c"
}

void
value_set_help_element (GValue* value,
                        gpointer v_object)
{
	HelpElement * old;
#line 24 "src/tbl_opts.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HELP_ELEMENT));
#line 24 "src/tbl_opts.vala"
	old = value->data[0].v_pointer;
#line 24 "src/tbl_opts.vala"
	if (v_object) {
#line 24 "src/tbl_opts.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HELP_ELEMENT));
#line 24 "src/tbl_opts.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "src/tbl_opts.vala"
		value->data[0].v_pointer = v_object;
#line 24 "src/tbl_opts.vala"
		help_element_ref (value->data[0].v_pointer);
#line 389 "tbl_opts.c"
	} else {
#line 24 "src/tbl_opts.vala"
		value->data[0].v_pointer = NULL;
#line 393 "tbl_opts.c"
	}
#line 24 "src/tbl_opts.vala"
	if (old) {
#line 24 "src/tbl_opts.vala"
		help_element_unref (old);
#line 399 "tbl_opts.c"
	}
}

void
value_take_help_element (GValue* value,
                         gpointer v_object)
{
	HelpElement * old;
#line 24 "src/tbl_opts.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HELP_ELEMENT));
#line 24 "src/tbl_opts.vala"
	old = value->data[0].v_pointer;
#line 24 "src/tbl_opts.vala"
	if (v_object) {
#line 24 "src/tbl_opts.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HELP_ELEMENT));
#line 24 "src/tbl_opts.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "src/tbl_opts.vala"
		value->data[0].v_pointer = v_object;
#line 420 "tbl_opts.c"
	} else {
#line 24 "src/tbl_opts.vala"
		value->data[0].v_pointer = NULL;
#line 424 "tbl_opts.c"
	}
#line 24 "src/tbl_opts.vala"
	if (old) {
#line 24 "src/tbl_opts.vala"
		help_element_unref (old);
#line 430 "tbl_opts.c"
	}
}

static void
help_element_class_init (HelpElementClass * klass,
                         gpointer klass_data)
{
#line 24 "src/tbl_opts.vala"
	help_element_parent_class = g_type_class_peek_parent (klass);
#line 24 "src/tbl_opts.vala"
	((HelpElementClass *) klass)->finalize = help_element_finalize;
#line 442 "tbl_opts.c"
}

static void
help_element_instance_init (HelpElement * self,
                            gpointer klass)
{
#line 24 "src/tbl_opts.vala"
	self->ref_count = 1;
#line 451 "tbl_opts.c"
}

static void
help_element_finalize (HelpElement * obj)
{
	HelpElement * self;
#line 24 "src/tbl_opts.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HELP_ELEMENT, HelpElement);
#line 24 "src/tbl_opts.vala"
	g_signal_handlers_destroy (self);
#line 462 "tbl_opts.c"
}

static GType
help_element_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_help_element_init, value_help_element_free_value, value_help_element_copy_value, value_help_element_peek_pointer, "p", value_help_element_collect_value, "p", value_help_element_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HelpElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) help_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HelpElement), 0, (GInstanceInitFunc) help_element_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType help_element_type_id;
	help_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HelpElement", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return help_element_type_id;
}

GType
help_element_get_type (void)
{
	static volatile gsize help_element_type_id__once = 0;
	if (g_once_init_enter (&help_element_type_id__once)) {
		GType help_element_type_id;
		help_element_type_id = help_element_get_type_once ();
		g_once_init_leave (&help_element_type_id__once, help_element_type_id);
	}
	return help_element_type_id__once;
}

gpointer
help_element_ref (gpointer instance)
{
	HelpElement * self;
	self = instance;
#line 24 "src/tbl_opts.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "src/tbl_opts.vala"
	return instance;
#line 497 "tbl_opts.c"
}

void
help_element_unref (gpointer instance)
{
	HelpElement * self;
	self = instance;
#line 24 "src/tbl_opts.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "src/tbl_opts.vala"
		HELP_ELEMENT_GET_CLASS (self)->finalize (self);
#line 24 "src/tbl_opts.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 511 "tbl_opts.c"
	}
}

Doc*
doc_construct (GType object_type,
               const gchar* text)
{
	Doc* self = NULL;
	gchar* _tmp0_;
#line 29 "src/tbl_opts.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 29 "src/tbl_opts.vala"
	self = (Doc*) help_element_construct (object_type);
#line 30 "src/tbl_opts.vala"
	_tmp0_ = g_strdup (text);
#line 30 "src/tbl_opts.vala"
	_g_free0 (self->text);
#line 30 "src/tbl_opts.vala"
	self->text = _tmp0_;
#line 29 "src/tbl_opts.vala"
	return self;
#line 533 "tbl_opts.c"
}

Doc*
doc_new (const gchar* text)
{
#line 29 "src/tbl_opts.vala"
	return doc_construct (TYPE_DOC, text);
#line 541 "tbl_opts.c"
}

static void
doc_class_init (DocClass * klass,
                gpointer klass_data)
{
#line 26 "src/tbl_opts.vala"
	doc_parent_class = g_type_class_peek_parent (klass);
#line 26 "src/tbl_opts.vala"
	((HelpElementClass *) klass)->finalize = doc_finalize;
#line 552 "tbl_opts.c"
}

static void
doc_instance_init (Doc * self,
                   gpointer klass)
{
}

static void
doc_finalize (HelpElement * obj)
{
	Doc * self;
#line 26 "src/tbl_opts.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOC, Doc);
#line 27 "src/tbl_opts.vala"
	_g_free0 (self->text);
#line 26 "src/tbl_opts.vala"
	HELP_ELEMENT_CLASS (doc_parent_class)->finalize (obj);
#line 571 "tbl_opts.c"
}

static GType
doc_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DocClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) doc_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Doc), 0, (GInstanceInitFunc) doc_instance_init, NULL };
	GType doc_type_id;
	doc_type_id = g_type_register_static (TYPE_HELP_ELEMENT, "Doc", &g_define_type_info, 0);
	return doc_type_id;
}

GType
doc_get_type (void)
{
	static volatile gsize doc_type_id__once = 0;
	if (g_once_init_enter (&doc_type_id__once)) {
		GType doc_type_id;
		doc_type_id = doc_get_type_once ();
		g_once_init_leave (&doc_type_id__once, doc_type_id);
	}
	return doc_type_id__once;
}

static GType
arg_type_get_type_once (void)
{
	static const GEnumValue values[] = {{ARG_TYPE_function, "ARG_TYPE_function", "function"}, {ARG_TYPE_loadfile, "ARG_TYPE_loadfile", "loadfile"}, {ARG_TYPE_file, "ARG_TYPE_file", "file"}, {0, NULL, NULL}};
	GType arg_type_type_id;
	arg_type_type_id = g_enum_register_static ("ArgType", values);
	return arg_type_type_id;
}

GType
arg_type_get_type (void)
{
	static volatile gsize arg_type_type_id__once = 0;
	if (g_once_init_enter (&arg_type_type_id__once)) {
		GType arg_type_type_id;
		arg_type_type_id = arg_type_get_type_once ();
		g_once_init_leave (&arg_type_type_id__once, arg_type_type_id);
	}
	return arg_type_type_id__once;
}

Opt*
opt_construct (GType object_type,
               const gchar* longname,
               gchar shortname,
               gint arg,
               const gchar* argstring,
               const gchar* docstring)
{
	Opt* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 43 "src/tbl_opts.vala"
	g_return_val_if_fail (longname != NULL, NULL);
#line 43 "src/tbl_opts.vala"
	g_return_val_if_fail (argstring != NULL, NULL);
#line 43 "src/tbl_opts.vala"
	g_return_val_if_fail (docstring != NULL, NULL);
#line 43 "src/tbl_opts.vala"
	self = (Opt*) help_element_construct (object_type);
#line 44 "src/tbl_opts.vala"
	_tmp0_ = g_strdup (longname);
#line 44 "src/tbl_opts.vala"
	_g_free0 (self->longname);
#line 44 "src/tbl_opts.vala"
	self->longname = _tmp0_;
#line 45 "src/tbl_opts.vala"
	self->shortname = shortname;
#line 46 "src/tbl_opts.vala"
	self->arg = arg;
#line 47 "src/tbl_opts.vala"
	_tmp1_ = g_strdup (argstring);
#line 47 "src/tbl_opts.vala"
	_g_free0 (self->argstring);
#line 47 "src/tbl_opts.vala"
	self->argstring = _tmp1_;
#line 48 "src/tbl_opts.vala"
	_tmp2_ = g_strdup (docstring);
#line 48 "src/tbl_opts.vala"
	_g_free0 (self->docstring);
#line 48 "src/tbl_opts.vala"
	self->docstring = _tmp2_;
#line 43 "src/tbl_opts.vala"
	return self;
#line 660 "tbl_opts.c"
}

Opt*
opt_new (const gchar* longname,
         gchar shortname,
         gint arg,
         const gchar* argstring,
         const gchar* docstring)
{
#line 43 "src/tbl_opts.vala"
	return opt_construct (TYPE_OPT, longname, shortname, arg, argstring, docstring);
#line 672 "tbl_opts.c"
}

static void
opt_class_init (OptClass * klass,
                gpointer klass_data)
{
#line 36 "src/tbl_opts.vala"
	opt_parent_class = g_type_class_peek_parent (klass);
#line 36 "src/tbl_opts.vala"
	((HelpElementClass *) klass)->finalize = opt_finalize;
#line 683 "tbl_opts.c"
}

static void
opt_instance_init (Opt * self,
                   gpointer klass)
{
}

static void
opt_finalize (HelpElement * obj)
{
	Opt * self;
#line 36 "src/tbl_opts.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_OPT, Opt);
#line 37 "src/tbl_opts.vala"
	_g_free0 (self->longname);
#line 40 "src/tbl_opts.vala"
	_g_free0 (self->argstring);
#line 41 "src/tbl_opts.vala"
	_g_free0 (self->docstring);
#line 36 "src/tbl_opts.vala"
	HELP_ELEMENT_CLASS (opt_parent_class)->finalize (obj);
#line 706 "tbl_opts.c"
}

static GType
opt_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (OptClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) opt_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Opt), 0, (GInstanceInitFunc) opt_instance_init, NULL };
	GType opt_type_id;
	opt_type_id = g_type_register_static (TYPE_HELP_ELEMENT, "Opt", &g_define_type_info, 0);
	return opt_type_id;
}

GType
opt_get_type (void)
{
	static volatile gsize opt_type_id__once = 0;
	if (g_once_init_enter (&opt_type_id__once)) {
		GType opt_type_id;
		opt_type_id = opt_get_type_once ();
		g_once_init_leave (&opt_type_id__once, opt_type_id);
	}
	return opt_type_id__once;
}

Arg*
arg_construct (GType object_type,
               const gchar* argstring,
               const gchar* docstring)
{
	Arg* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 56 "src/tbl_opts.vala"
	g_return_val_if_fail (argstring != NULL, NULL);
#line 56 "src/tbl_opts.vala"
	g_return_val_if_fail (docstring != NULL, NULL);
#line 56 "src/tbl_opts.vala"
	self = (Arg*) help_element_construct (object_type);
#line 57 "src/tbl_opts.vala"
	_tmp0_ = g_strdup (argstring);
#line 57 "src/tbl_opts.vala"
	_g_free0 (self->argstring);
#line 57 "src/tbl_opts.vala"
	self->argstring = _tmp0_;
#line 58 "src/tbl_opts.vala"
	_tmp1_ = g_strdup (docstring);
#line 58 "src/tbl_opts.vala"
	_g_free0 (self->docstring);
#line 58 "src/tbl_opts.vala"
	self->docstring = _tmp1_;
#line 56 "src/tbl_opts.vala"
	return self;
#line 758 "tbl_opts.c"
}

Arg*
arg_new (const gchar* argstring,
         const gchar* docstring)
{
#line 56 "src/tbl_opts.vala"
	return arg_construct (TYPE_ARG, argstring, docstring);
#line 767 "tbl_opts.c"
}

static void
arg_class_init (ArgClass * klass,
                gpointer klass_data)
{
#line 52 "src/tbl_opts.vala"
	arg_parent_class = g_type_class_peek_parent (klass);
#line 52 "src/tbl_opts.vala"
	((HelpElementClass *) klass)->finalize = arg_finalize;
#line 778 "tbl_opts.c"
}

static void
arg_instance_init (Arg * self,
                   gpointer klass)
{
}

static void
arg_finalize (HelpElement * obj)
{
	Arg * self;
#line 52 "src/tbl_opts.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARG, Arg);
#line 53 "src/tbl_opts.vala"
	_g_free0 (self->argstring);
#line 54 "src/tbl_opts.vala"
	_g_free0 (self->docstring);
#line 52 "src/tbl_opts.vala"
	HELP_ELEMENT_CLASS (arg_parent_class)->finalize (obj);
#line 799 "tbl_opts.c"
}

static GType
arg_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ArgClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arg_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Arg), 0, (GInstanceInitFunc) arg_instance_init, NULL };
	GType arg_type_id;
	arg_type_id = g_type_register_static (TYPE_HELP_ELEMENT, "Arg", &g_define_type_info, 0);
	return arg_type_id;
}

GType
arg_get_type (void)
{
	static volatile gsize arg_type_id__once = 0;
	if (g_once_init_enter (&arg_type_id__once)) {
		GType arg_type_id;
		arg_type_id = arg_get_type_once ();
		g_once_init_leave (&arg_type_id__once, arg_type_id);
	}
	return arg_type_id__once;
}

void
init_cmdline (void)
{
	Doc* _tmp0_;
	Doc* _tmp1_;
	Opt* _tmp2_;
	Opt* _tmp3_;
	Opt* _tmp4_;
	Opt* _tmp5_;
	Opt* _tmp6_;
	Doc* _tmp7_;
	Doc* _tmp8_;
	Doc* _tmp9_;
	Arg* _tmp10_;
	Arg* _tmp11_;
	HelpElement** _tmp12_;
#line 70 "src/tbl_opts.vala"
	_tmp0_ = doc_new ("Initialization options:");
#line 70 "src/tbl_opts.vala"
	_tmp1_ = doc_new ("");
#line 70 "src/tbl_opts.vala"
	_tmp2_ = opt_new ("no-init-file", 'q', (gint) optional_argument, "", "do not load ~/." PACKAGE);
#line 70 "src/tbl_opts.vala"
	_tmp3_ = opt_new ("funcall", 'f', (gint) required_argument, "FUNC", "call " PACKAGE_NAME " Lisp function FUNC with no arguments");
#line 70 "src/tbl_opts.vala"
	_tmp4_ = opt_new ("load", 'l', (gint) required_argument, "FILE", "load " PACKAGE_NAME " Lisp FILE using the load function");
#line 70 "src/tbl_opts.vala"
	_tmp5_ = opt_new ("help", '\0', (gint) optional_argument, "", "display this help message and exit");
#line 70 "src/tbl_opts.vala"
	_tmp6_ = opt_new ("version", '\0', (gint) optional_argument, "", "display version information and exit");
#line 70 "src/tbl_opts.vala"
	_tmp7_ = doc_new ("");
#line 70 "src/tbl_opts.vala"
	_tmp8_ = doc_new ("Action options:");
#line 70 "src/tbl_opts.vala"
	_tmp9_ = doc_new ("");
#line 70 "src/tbl_opts.vala"
	_tmp10_ = arg_new ("FILE", "visit FILE using find-file");
#line 70 "src/tbl_opts.vala"
	_tmp11_ = arg_new ("+LINE FILE", "visit FILE using find-file, then go to line LINE");
#line 70 "src/tbl_opts.vala"
	_tmp12_ = g_new0 (HelpElement*, 12 + 1);
#line 70 "src/tbl_opts.vala"
	_tmp12_[0] = (HelpElement*) _tmp0_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[1] = (HelpElement*) _tmp1_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[2] = (HelpElement*) _tmp2_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[3] = (HelpElement*) _tmp3_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[4] = (HelpElement*) _tmp4_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[5] = (HelpElement*) _tmp5_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[6] = (HelpElement*) _tmp6_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[7] = (HelpElement*) _tmp7_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[8] = (HelpElement*) _tmp8_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[9] = (HelpElement*) _tmp9_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[10] = (HelpElement*) _tmp10_;
#line 70 "src/tbl_opts.vala"
	_tmp12_[11] = (HelpElement*) _tmp11_;
#line 70 "src/tbl_opts.vala"
	opts = (_vala_array_free (opts, opts_length1, (GDestroyNotify) help_element_unref), NULL);
#line 70 "src/tbl_opts.vala"
	opts = _tmp12_;
#line 70 "src/tbl_opts.vala"
	opts_length1 = 12;
#line 70 "src/tbl_opts.vala"
	_opts_size_ = opts_length1;
#line 897 "tbl_opts.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

